Index: docs/ref/contrib/localflavor.txt
===================================================================
--- docs/ref/contrib/localflavor.txt	(revision 16452)
+++ docs/ref/contrib/localflavor.txt	(working copy)
@@ -784,6 +784,17 @@
     A ``Select`` widget that uses a list of Norwegian municipalities (fylker) as
     its choices.
 
+Paraguay (``py``)
+=================
+
+.. class:: py.forms.PyDepartmentSelect
+
+    A ``Select`` widget with a list of Paraguayan departments as choices.
+
+.. class:: py.forms.PyNumeratedDepartmentSelect
+
+    A ``Select`` widget with a roman numerated list of Paraguayan departments as choices.
+
 Peru (``pe``)
 =============
 
Index: django/contrib/localflavor/py/py_department.py
===================================================================
--- django/contrib/localflavor/py/py_department.py	(revision 0)
+++ django/contrib/localflavor/py/py_department.py	(revision 0)
@@ -0,0 +1,41 @@
+# -*- coding: utf-8 -*-
+
+DEPARTMENT_CHOICES = (
+    ('A', u'Concepción'),
+    ('B', u'San Pedro'),
+    ('C', u'Cordillera'),
+    ('D', u'Guairá'),
+    ('E', u'Caaguazú'),
+    ('F', u'Caazapá'),
+    ('G', u'Itapúa'),
+    ('H', u'Misiones'),
+    ('I', u'Paraguarí'),
+    ('J', u'Alto Paraná'),
+    ('K', u'Central'),
+    ('L', u'Ñeembucú'),
+    ('M', u'Amambay'),
+    ('N', u'Canindeyú'),
+    ('O', u'Pdte. Hayes'),
+    ('P', u'Alto Paraguay'),
+    ('Q', u'Boquerón'),
+)
+
+DEPARTMENT_ROMAN_CHOICES = (
+    ('A',  u'I    Concepción'),
+    ('B',  u'II   San Pedro'),
+    ('C',  u'III  Cordillera'),
+    ('D',  u'IV   Guairá'),
+    ('E',  u'V    Caaguazú'),
+    ('F',  u'VI   Caazapá'),
+    ('G',  u'VII  Itapúa'),
+    ('H',  u'VIII Misiones'),
+    ('I',  u'IX   Paraguarí'),
+    ('J',  u'X    Alto Paraná'),
+    ('K',  u'XI   Central'),
+    ('L',  u'XII  Ñeembucú'),
+    ('M',  u'XIII Amambay'),
+    ('N',  u'XIV  Canindeyú'),
+    ('O',  u'XV   Pdte. Hayes'),
+    ('P',  u'XVI  Alto Paraguay'),
+    ('Q',  u'XVII Boquerón'),
+)
Index: django/contrib/localflavor/py/__init__.py
===================================================================
Index: django/contrib/localflavor/py/forms.py
===================================================================
--- django/contrib/localflavor/py/forms.py	(revision 0)
+++ django/contrib/localflavor/py/forms.py	(revision 0)
@@ -0,0 +1,24 @@
+# -*- coding: utf-8 -*-
+"""
+PY-specific Form helpers.
+"""
+
+from django.forms import ValidationError
+from django.forms.fields import RegexField, CharField, Select, EMPTY_VALUES
+
+class PyDepartmentSelect(Select):
+    """
+    A Select widget with a list of Paraguayan departments as choices.
+    """
+    def __init__(self, attrs=None):
+        from py_department import DEPARTMENT_CHOICES
+        super(PyDepartmentSelect, self).__init__(attrs, choices=DEPARTMENT_CHOICES)
+
+
+class PyNumeratedDepartmentSelect(Select):
+    """
+    A Select widget with a roman numerated list of Paraguayan departments as choices.
+    """
+    def __init__(self, attrs=None):
+        from py_department import DEPARTMENT_ROMAN_CHOICES
+        super(PyNumeratedDepartmentSelect, self).__init__(attrs, choices=DEPARTMENT_ROMAN_CHOICES)
Index: tests/regressiontests/forms/tests/__init__.py
===================================================================
--- tests/regressiontests/forms/tests/__init__.py	(revision 16452)
+++ tests/regressiontests/forms/tests/__init__.py	(working copy)
@@ -40,6 +40,7 @@
     NLLocalFlavorTests,
     PLLocalFlavorTests,
     PTLocalFlavorTests,
+    PYLocalFlavorTests,
     ROLocalFlavorTests,
     RULocalFlavorTests,
     SELocalFlavorTests,
Index: tests/regressiontests/forms/localflavor/py.py
===================================================================
--- tests/regressiontests/forms/localflavor/py.py	(revision 0)
+++ tests/regressiontests/forms/localflavor/py.py	(revision 0)
@@ -0,0 +1,51 @@
+from django.contrib.localflavor.py.forms import (PyDepartmentSelect,
+    PyNumeratedDepartmentSelect)
+
+from utils import LocalFlavorTestCase
+
+class PYLocalFlavorTests(LocalFlavorTestCase):
+    def test_PyDepartmentSelect(self):
+        py = PyDepartmentSelect()
+        out = u'''<select name="department">
+<option value="A">Concepci\xf3n</option>
+<option value="B">San Pedro</option>
+<option value="C">Cordillera</option>
+<option value="D">Guair\xe1</option>
+<option value="E">Caaguaz\xfa</option>
+<option value="F">Caazap\xe1</option>
+<option value="G">Itap\xfaa</option>
+<option value="H">Misiones</option>
+<option value="I">Paraguar\xed</option>
+<option value="J">Alto Paran\xe1</option>
+<option value="K">Central</option>
+<option value="L">\xd1eembuc\xfa</option>
+<option value="M" selected="selected">Amambay</option>
+<option value="N">Canindey\xfa</option>
+<option value="O">Pdte. Hayes</option>
+<option value="P">Alto Paraguay</option>
+<option value="Q">Boquer\xf3n</option>
+</select>'''
+        self.assertEqual(py.render('department', 'M'), out)
+
+    def test_PyNumeratedDepartmentSelect(self):
+        py = PyNumeratedDepartmentSelect()
+        out = u'''<select name="department">
+<option value="A">I    Concepci\xf3n</option>
+<option value="B">II   San Pedro</option>
+<option value="C">III  Cordillera</option>
+<option value="D">IV   Guair\xe1</option>
+<option value="E">V    Caaguaz\xfa</option>
+<option value="F">VI   Caazap\xe1</option>
+<option value="G">VII  Itap\xfaa</option>
+<option value="H">VIII Misiones</option>
+<option value="I">IX   Paraguar\xed</option>
+<option value="J">X    Alto Paran\xe1</option>
+<option value="K">XI   Central</option>
+<option value="L">XII  \xd1eembuc\xfa</option>
+<option value="M" selected="selected">XIII Amambay</option>
+<option value="N">XIV  Canindey\xfa</option>
+<option value="O">XV   Pdte. Hayes</option>
+<option value="P">XVI  Alto Paraguay</option>
+<option value="Q">XVII Boquer\xf3n</option>
+</select>'''
+        self.assertEqual(py.render('department', 'M'), out)
Index: tests/regressiontests/forms/localflavortests.py
===================================================================
--- tests/regressiontests/forms/localflavortests.py	(revision 16452)
+++ tests/regressiontests/forms/localflavortests.py	(working copy)
@@ -27,6 +27,7 @@
 from localflavor.nl import NLLocalFlavorTests
 from localflavor.pl import PLLocalFlavorTests
 from localflavor.pt import PTLocalFlavorTests
+from localflavor.py import PYLocalFlavorTests
 from localflavor.ro import ROLocalFlavorTests
 from localflavor.ru import RULocalFlavorTests
 from localflavor.se import SELocalFlavorTests